function getCategories() {
  AJAX.get(API.category)
  .then((res) => res.json())
  .then((res) => {
    if(res.Success === undefined){
      var table = document.getElementById("categoriesTable");
      table.innerHTML = '';
      res.map((item) => {
        let res = document.createElement('tr');
        let td1 = document.createElement('td');
        let td2 = document.createElement('td');
        let td3 = document.createElement('td');
        td1.innerHTML = item.name;
        td2.innerHTML = item.description;
        let button = document.createElement('button');
        button.innerHTML = 'Удалить';
        button.onclick = function (event) {
          let id = item._id;
          AJAX.delete(API.category, id)
          .then(respons => respons.json())
          .then(respons => {
            // TODO: обработка ответа
            if(respons.success){
              table.removeChild(res);
            }
          });
          event.stopPropagation()
        }

        let buttonEdit = document.createElement('button');
        buttonEdit.innerHTML = 'Изменить';
        buttonEdit.onclick = function (event) {
          let id = item._id;
          goToCategoriesEdit(id);
          event.stopPropagation()
        }
        button.className = 'btn btn-danger';
        buttonEdit.className = 'btn btn-info';
        td3.appendChild(button);
        td3.appendChild(buttonEdit);
        res.appendChild(td1);
        res.appendChild(td2);
        res.appendChild(td3);
        res.onclick = function() {
          let id = item._id;
          goToProduct(id);
        }
        table.appendChild(res);
      })
    }else {
      // TODO: обработка искючения
    }
  });
}

function addCategories() {
  let name = document.getElementById('categoriesNew-name').value;
  let description = document.getElementById('categoriesNew-description').value;
  AJAX.post(API.category, { name, description })
  .then(res => res.json())
  .then(res => {
    goToCategories();
    // TODO: обработка исключения
  });
}

function getCategory(id) {
  AJAX.get(API.category + '/' + id)
  .then(respons => respons.json())
  .then(respons => {
    let name = document.getElementById('categoriesEdit-name');
    let description = document.getElementById('categoriesEdit-description');
    name.value = respons.name;
    description.value = respons.description;
  })
  .catch((r) => console.log(r));
}

function editCategories() {
  let name = document.getElementById('categoriesEdit-name').value;
  let description = document.getElementById('categoriesEdit-description').value;
  let id = location.pathname.split('/')[2];
  AJAX.put(API.category + '/' + id, { name, description })
  .then(res => res.json())
  .then(res => {
    if(res.success){
      goToCategories();
    }
  });
}
