var states = ['auth', 'register', 'categories', 'categoriesNew', 'categoriesEdit', 'product', 'productNew', 'productEdit'];

function goTo(nameSate, nameUrl) {
  states.map((state) => {
    document.getElementById(state).style.display = 'none';
  })
  document.getElementById(nameSate).style.display = 'block';
  if(location.pathname  != nameUrl){
    history.pushState({}, 'Hello World', nameUrl);
  }
  var token = localStorage.getItem('token');
  if(!token && nameSate != 'auth' && nameSate != 'register'){
    goToAuth();
  }
}

function goToRegister() {
  goTo('register', '/register');
}

function goToAuth() {
  goTo('auth', '/auth');
}

function goToCategories() {
  goTo('categories', '/categories');
  getCategories();
}

function goToCategoriesNew() {
  goTo('categoriesNew', '/categories/new');
  document.getElementById('categoriesNew-name').value = ' ';
  document.getElementById('categoriesNew-description').value = ' ';
}

function goToCategoriesEdit(id) {
  goTo('categoriesEdit', '/categories/' + id);
  getCategory(id);
}

function goToProduct(id) {
  if(!id) {
    id = location.pathname.split('/')[2];
  }
  goTo('product', `/categories/${id}/product`);
  getProducts(id);
}

function goToProductNew() {
  let idCategory = location.pathname.split('/')[2];
  goTo('productNew', `/categories/${idCategory}/product/new`);
  document.getElementById('productNew-name').value = ' ';
  document.getElementById('productNew-description').value = ' ';
  document.getElementById('productNew-price').value = ' ';
}

function goToProductEdit(id) {
  let idCategory = location.pathname.split('/')[2];
  goTo('productEdit',  `/categories/${idCategory}/product/${id}`);
  getProduct(id);
}

(function functionName() {
  switch (location.pathname) {
    case '/register':
      goToRegister();
      break;
    case '/auth':
      goToAuth();
      break;
    case '/categories':
      goToCategories();
      break;
    case '/categories/new':
      goToCategoriesNew();
      break;
    case '/product':
      goToProduct();
      break;
    default:
      let urls = location.pathname.split('/');
      if(urls[1] == 'categories' && urls.length == 3){
        goToCategoriesEdit(urls[2]);
      } else if(urls[1] == 'categories' && urls.length == 4 && urls[3] == 'product'){
        goToProduct(urls[2]);
      } else if(urls[1] == 'categories' && urls.length == 5 && urls[3] == 'product' && urls[4] == 'new'){
        goToProductNew();
      } else if(urls[1] == 'categories' && urls.length == 5 && urls[3] == 'product'){
        goToProductEdit(urls[4]);
      } else {
        goToCategories();
      }
      break;
  }
})()
