function getData(data) {
  let res = '';
  // 'foo=bar&lorem=ipsum'
  for (var prop in data) {
    res += prop + '='+ data[prop] + '&';
  }
  return res;
}

function register() {
  let login = document.getElementById('register-login').value;
  let password = document.getElementById('register-password').value;
  let confirmPassword = document.getElementById('register-confirmPassword').value;
  fetch(apiUrl + API.authRegistr,
  {
      method: "post",
      headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
      },
      body: getData({
        login: login,
        password: password,
        confirmPassword: confirmPassword
      })
  }).then((res) => {return res.json()})
  .then((res) => {
    if(res.success){
      localStorage.setItem('token', res.token);
      goToCategories();
    } else {
      // TODO: обработка ошибок
    }
  })
  .catch((req) => alert(req));
}


function auth() {
  let login = document.getElementById('auth-login').value;
  let password = document.getElementById('auth-password').value;
  fetch(apiUrl + API.auth,
  {
      method: "post",
      headers: {
         'Content-Type': 'application/x-www-form-urlencoded'
      },
      body: getData({
        login: login,
        password: password
      })
  }).then((res) => {return res.json()})
  .then((res) => {
    if(res.success){
      localStorage.setItem('token', res.token);
      goToCategories();
    } else{
      // TODO: обработка ошибок
    }
  })
  .catch((req) => alert(req));
}

function logout() {
  localStorage.clear();
  goToAuth();
}
