function getProducts(idCategory) {
  AJAX.get(API.product + '?category=' + idCategory)
  .then((res) => res.json())
  .then((res) => {
    if(res.Success === undefined){
      var productArrays = document.getElementById("productArrays");
      productArrays.innerHTML = '';
      res.map((item) => {

        let el = document.createElement('div');
        el.className = 'product';
        let img = document.createElement('img');
        let pName = document.createElement('p');
        let pPrice = document.createElement('p');
        pName.innerHTML = item.name;
        pPrice.innerHTML = item.price;
        img.src = "img/milk.jpg";
        img.alt = "milk";
        let button = document.createElement('button');
        button.innerHTML = 'Удалить';
        button.onclick = function (event) {
          let id = item._id;
          AJAX.delete(API.product, id)
          .then(respons => respons.json())
          .then(respons => {
            // TODO: обработка ответа
            if(respons.success){
              productArrays.removeChild(el);
            }
          });
          event.stopPropagation()
        }
        let buttonEdit = document.createElement('button');
        buttonEdit.innerHTML = 'Изменить';
        buttonEdit.onclick = function (event) {
          let id = item._id;
          goToProductEdit(id);
          event.stopPropagation()
        }
        button.className = 'btn btn-danger';
        buttonEdit.className = 'btn btn-info';
        el.appendChild(img);
        el.appendChild(pName);
        el.appendChild(pPrice);
        el.appendChild(button);
        el.appendChild(buttonEdit);
        productArrays.appendChild(el);
      })
    }else {
      // TODO: обработка искючения
    }
  });
}

function addProduct() {
  let name = document.getElementById('productNew-name').value;
  let description = document.getElementById('productNew-description').value;
  var price = document.getElementById('productNew-price').value;
  let idCategory = location.pathname.split('/')[2];
  AJAX.post(API.product, { name, description, price, category: idCategory })
  .then(res => res.json())
  .then(res => {
    goToProduct(res.category);
    // TODO: обработка исключения
  });
}

function getProduct(id) {
  AJAX.get(API.product + '/' + id)
  .then(respons => respons.json())
  .then(respons => {
    let name = document.getElementById('productEdit-name');
    let description = document.getElementById('productEdit-description');
    var price = document.getElementById('productEdit-price');
    name.value = respons.name;
    description.value = respons.description;
    price.value = respons.price;
  })
  .catch((r) => console.log(r));
}

function editProduct() {
  let name = document.getElementById('productEdit-name').value;
  let description = document.getElementById('productEdit-description').value;
  var price = document.getElementById('productEdit-price').value;
  let id = location.pathname.split('/')[4];
  AJAX.put(API.product + '/' + id, { name, description, price })
  .then(res => res.json())
  .then(res => {
    if(res.success){
      goToProduct(location.pathname.split('/')[2]);
    }
  });
}
